/* Copyright (c) 2006-2018 Peter Speck / Vitality. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Vitality nor the names of its contributors may be
 *       used to endorse or promote products derived from this software without
 *       specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PETER SPECK / VITALITY AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL PETER SPECK / VITALITY AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package org.jabhts.translator.compiler.codeGeneration.impl;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import org.jabhts.translator.compiler.application.scope.Scope;
import org.jabhts.translator.compiler.application.scope.ScopeImpl;
import org.jabhts.translator.compiler.codeGeneration.api.IteratorInfo;

class Callback
{
	final ScopeImpl scope;
	final Field field;
	final Method method;
	final CallbackType callbackType;
	final IteratorInfo iterInfo;
	final String key;

	enum CallbackType
	{
		CallMethod,
		GetStringField, GetBooleanField, GetIntegerField, GetIteratorField,
		EnterScope, LeaveScope,
		IteratorStep
	}

	Callback(Scope scope, Field field, Method method, IteratorInfo iterInfo, CallbackType callbackType, String key)
	{
		this.scope = (ScopeImpl)scope;
		this.field = field;
		this.method = method;
		this.iterInfo = iterInfo;
		this.callbackType = callbackType;
		this.key = key;
	}
}
