#!/usr/bin/perl

use strict;

my $licensePath = "LICENSE.txt";
if (@ARGV && $ARGV[0] eq "--license") {
	shift;
	$licensePath = shift;
}
my $dirs = @ARGV ? join(" ", @ARGV) : "src";
print STDERR "# files in: $dirs\n";

open(FH, $licensePath) || die "Can't open $licensePath: $!\n";
my $copy = join("", <FH>);
close(FH);
$copy =~ s/(Copyright.*?) 20\d\d(-20\d\d)? /$1 YEARYEAR /;
$copy =~ s/\n/\n * /g;
$copy =~ s/ +\n/\n/g;
$copy = "/* $copy";
$copy =~ s{\s*$}{/\n};
if (0) {
	print $copy;
	exit 1;
}

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
my $thisYear = $year + 1900;

my $dryrun = 0;

open(FL, "find $dirs -type f |") || die;
while (<FL>) {
	chomp;
	next unless /\.(java|h|m|pch)$/;
#next if m!/vitality/lib/!;
	my $fn = $_;
	open(FH, $fn) || die "Can't read $fn: $!";
	my $j = join("", <FH>);
	close(FH);
	my $copy2;
	if ($j =~ m{/\* Copyright.*? (20\d\d)(?:-20\d\d)?[, ]} && $1 ne $thisYear) {
		my $old = $1;
		($copy2 = $copy) =~ s{YEARYEAR}{$old-$thisYear};
	} else {
		($copy2 = $copy) =~ s{YEARYEAR}{$thisYear};
	}
	next if index($j, $copy2) >= 0;
	next if $j =~ /THIS IS AUTOGENERATED CODE/;
	if ($j =~ s{/\* Copyright.*Peter Speck.*\n( \*.*\n)* \*/\n+}{}) {
		print STDERR "### $fn has old/wrong copyright notice.\n";
	} else {
		print STDERR "### $fn is missing copyright\n";
	}
	if ($fn =~ /\.java$/ && $j !~ /^\s*package/) {
		die "###   but has garbage at start\n";
	}
	next if $dryrun;
	my $fntmp = "$fn.tmp";
	open(FH, ">$fntmp") || die "Can't write to $fntmp";
	print FH $copy2, "\n", $j;
	close(FH);
	rename($fntmp, $fn) || die "Can't rename $fntmp to $fn";
}
