/* Copyright (C) 2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

@interface InstallerMainWindow : NSWindow
{
	
}

- (instancetype)initWithContentRect:(NSRect)contentRect
						  styleMask:(NSUInteger)windowStyle
							backing:(NSBackingStoreType)bufferingType
							  defer:(BOOL)deferCreation;

- (instancetype)initWithContentRect:(NSRect)contentRect
						  styleMask:(NSUInteger)windowStyle
							backing:(NSBackingStoreType)bufferingType
							  defer:(BOOL)deferCreation
							 screen:(NSScreen *)screen;

- (void)dealloc;
@end

@implementation InstallerMainWindow

- (instancetype)initWithContentRect:(NSRect)contentRect
						  styleMask:(NSUInteger)windowStyle
							backing:(NSBackingStoreType)bufferingType
							  defer:(BOOL)deferCreation
{
	//NSLog(@"creates InstallerMainWindow.1");
	if (!(self = [super initWithContentRect:contentRect styleMask:windowStyle backing:bufferingType defer:deferCreation]))
		return nil;
	return self;
}

- (instancetype)initWithContentRect:(NSRect)contentRect
						  styleMask:(NSUInteger)windowStyle
							backing:(NSBackingStoreType)bufferingType
							  defer:(BOOL)deferCreation
							 screen:(NSScreen *)screen
{
	//NSLog(@"creates InstallerMainWindow.2");
	if (!(self = [super initWithContentRect:contentRect styleMask:windowStyle backing:bufferingType defer:deferCreation screen:screen]))
		return nil;
	return self;
}

- (void)dealloc
{
}

- (NSTimeInterval)animationResizeTime:(NSRect)newWindowFrame
{
	NSTimeInterval t = [super animationResizeTime:newWindowFrame];
	//NSLog(@"InstallerMainWindow.animationResizeTime: %f", t);
	t = MIN(t, 0.05);
	return t;
}

@end

