/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
#import "VerticalViewFlow.h"

@class FilterListDropView;
@class FilterTabController;
@class Filter;
@class Prefs;

@interface FilterListView : VerticalViewFlow <NSDraggingSource> {

@private
	FilterTabController* _controller;
	Prefs* _prefs;
	FilterListDropView* _dropDestinationView;
	Filter* _srcFilter;
}

- (instancetype)initWithFrame:(NSRect)frameRect;
- (void)dealloc;
- (void)setController:(FilterTabController*)controller;
- (void)startDrag:(Filter*)filter withImage:(NSImage*)image withEvent:(NSEvent*)event;

- (BOOL)validateMenuItem:(NSMenuItem *)item;
- (void)paste:(id)sender;

@end
