/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
#import "CodeEditHelper.h"

@class Prefs;
@class AlertHelper;
@class ServerCommunication;
@class FilterTabController;
@class Filter;
@class FilterRuleTextField;
@class ClickActionTextField;
@class FilterRuleFieldEditor;
@class XmlDoc;

@interface FilterRuleEdit : NSObject<CodeEditDelegate,NSWindowDelegate,NSTabViewDelegate,NSTextViewDelegate,NSTextFieldDelegate,NSTextStorageDelegate> {
}

- (instancetype)initWithFilterTabController:(FilterTabController*)filterTabController
							withOwnerFilter:(Filter*)ownerFilter
							withRuleElement:(NSXMLElement*)ruleE
						 withSuspectElement:(NSXMLElement*)suspectE;
- (void)dealloc;

- (IBAction)cancelAction:(id)sender;
- (IBAction)commitAction:(id)sender;
- (IBAction)previewAction:(id)sender;

- (IBAction)updateDependentStates:(id)sender;

- (IBAction)requestHelpAction:(id)sender;
- (IBAction)transformHelpAction:(id)sender;
- (IBAction)expansionHelpAction:(id)sender;

- (BOOL)handlePasteUrl:(NSString*)txt withTextField:(NSTextField*)textField;

- (void)syntaxHighlightRegExp:(NSMutableAttributedString*)attributedString;

+ (int)getRuleId:(NSXMLElement*)ruleE;
@end
