/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <PreferencePanes/PreferencePanes.h>
#import "ProxyScriptEditor.h"

@class ServerCommunication;
@class AlertHelper;
@class Prefs;
@class FilterTabController;
@class HistoryController;
@class SuspectsController;
@class InstallationHelper;
@class SFAuthorizationView;

@interface GlimmerBlockerPrefsPane : NSPreferencePane <ProxyScriptEditorDelegate,NSTabViewDelegate>
{
}

-(instancetype)initWithBundle:(NSBundle*)bundle;
- (void)dealloc;

- (void)mainViewDidLoad;

- (IBAction)setupEnableGlimmerBlockerAction:(id)sender;
- (IBAction)setupConfirmNetworkSettingsAction:(id)sender;
- (IBAction)setupSyncNetworkSettingsNowAction:(id)sender;
- (IBAction)networkSiteProxyScriptEditAction:(id)sender;

- (IBAction)setupUpdatesAutoAction:(id)sender;
- (IBAction)setupUpdatesManualAction:(id)sender;
- (IBAction)setupUpdatesBetaAction:(id)sender;

- (IBAction)networkPortNumberAction:(id)sender;
- (IBAction)networkAllowOtherComputersAction:(id)sender;
- (IBAction)networkSiteProxyAction:(id)sender;
//
- (IBAction)developerDebugFlagsAction:(id)sender;
- (IBAction)developerShowLogAction:(id)sender;
- (IBAction)developerDumpHttpClientCacheAction:(id)sender;

- (IBAction)debugInternalSystemLog:(id)sender;
- (IBAction)debugInternalRunTcpTests:(id)sender;

+ (void)openWebsiteInBrowser;

@end

