/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import "ClickActionTextField.h"
#import "GlimmerBlockerPane.h"


@interface ClickActionTextField()

@property id theTarget;
@property SEL selector;

@end

@implementation ClickActionTextField

- (void)setTarget:(id)target selector:(SEL)selector
{
	_theTarget = target;
	_selector = selector;
}

- (void)mouseDown:(NSEvent*)theEvent
{
	// http://theocacao.com/document.page/264
	NSMethodSignature* sig = [[_theTarget class] instanceMethodSignatureForSelector:_selector];
	NSInvocation* invo = [NSInvocation invocationWithMethodSignature:sig];
	[invo setTarget:_theTarget];
	[invo setSelector:_selector];
	[invo setArgument:(__bridge void *)(self) atIndex:2];
	[invo invoke];
}

- (void)resetCursorRects
{
	[self addCursorRect:[self bounds] cursor:[NSCursor pointingHandCursor]];
}

@end

//------------------------------------------------------------------------

@implementation OpenWebsiteOnClickTextField

- (void)mouseDown:(NSEvent *)theEvent
{
	[GlimmerBlockerPrefsPane openWebsiteInBrowser];
}

- (void)resetCursorRects
{
	[self addCursorRect:[self bounds] cursor:[NSCursor pointingHandCursor]];
}

@end

//------------------------------------------------------------------------

@implementation OpenWebsiteOnClickImage

- (void)mouseDown:(NSEvent *)theEvent
{
	[GlimmerBlockerPrefsPane openWebsiteInBrowser];
}

- (void)resetCursorRects
{
	[self addCursorRect:[self bounds] cursor:[NSCursor pointingHandCursor]];
}

@end
