/* Copyright (C) 2009-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Just a simple test for checking if users can run Java.
 */
public class TestJava
{
	public static void main(String[] args)
	{
		StringBuilder sb = new StringBuilder(200);
		sb.append("chars:");
		byte[] b = new byte[]{
				//(byte)0x9E, (byte)0xE9, (byte)0xCA, (byte)0xB2, (byte)0xFC, (byte)0x4E, (byte)0xD2, (byte)0xAA, (byte)0xD3, (byte)0xC3
				(byte)0xB4, (byte)0xA6, (byte)0xC0, (byte)0xED, (byte)0xD6, (byte)0xD0, (byte)0xCE, (byte)0xC4, (byte)0xCE, (byte)0xCA, (byte)0xCC, (byte)0xE2
				//(byte)0x88, (byte)0xcc, (byte)0xd0, (byte)0xd0
				};
		for (int x : b)
			sb.append(String.format("  0x%X", 255 & x));
		sb.append("\n");
		try {
			String s = new String(b, "Big5_HKSCS");
			sb.append(s);
			sb.append("!");
			byte[] b2 = s.getBytes("Big5_HKSCS");
			for (int x : b2)
				sb.append(String.format("  0x%X", 255 & x));
			sb.append("\n");
			sb.append("360: ").append(Arrays.toString(b2)).append("\n");
		}
		catch (Exception ex) {
			sb.append("ex: ").append(ex.getMessage()).append("\n");
		}
		/*
		System.err.println("TestJava running.");
		System.err.println("Java version: " + System.getProperty("java.version"));
		System.err.println("Mac OS X version: " + System.getProperty("os.version"));
		Runtime r = Runtime.getRuntime();
		long free = r.freeMemory();
		long total = r.totalMemory();
		System.err.println("freeMemory = " + kb(free) + " KB" +
				", totalMemory = " + kb(total) + " KB" +
				", maxMemory = " + kb(r.maxMemory()) + " KB" +
				", used = " + kb(total - free) + " KB" +
				"");
		Properties props = System.getProperties();
		for (Object k : props.keySet())
			System.err.println("Property  " + k + ": " + props.get(k));
		*/
		System.err.println(sb.toString());

		List<String> list = new ArrayList<>();
		list.add("abc");
		if (list.stream().count() != 1)
			System.err.println("Non-empty list is not non-empty");
	}

	private static long kb(long x)
	{
		return (x + 512) / 1024;
	}
}
