/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.http.client.cache;

import java.io.PrintWriter;
import org.glimmerblocker.proxy.http.client.connection.HttpClientConnection;
import org.jetbrains.annotations.NotNull;
import dk.vitality.lib.connectionCache.ConnectionInfo;

public class CacheableHttpConnection implements ConnectionInfo<HttpClientConnection>
{
	@NotNull protected final HttpClientConnection conn;

	public CacheableHttpConnection(@NotNull HttpClientConnection conn)
	{
		this.conn = conn;
	}

	public void debugDump(@NotNull String indent, @NotNull PrintWriter pw)
	{
		pw.print(indent);
		pw.println(conn.getState());
	}

	public boolean isClosed() throws Exception
	{
		return !conn.skt.isConnected();
	}

	public boolean isReusable()
	{
		return conn.isReusable();
	}

	public void abort()
	{
		conn.forcedSocketClose();
	}

	@NotNull
	public HttpClientConnection getConnection()
	{
		return conn;
	}
}
