/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.rhino.callback;

import org.jetbrains.annotations.NotNull;
import org.mozilla.javascript.Context;

public class DebugSubObject extends CallbackSubObject
{
	@NotNull private static final CallbackRhinoBinder classBinder = new CallbackRhinoBinder(DebugSubObject.class);

	public DebugSubObject(@NotNull CallbackObjectBase parent)
	{
		super(parent, classBinder);
	}

	public DebugSubObject(@NotNull CallbackObjectBase parent, @NotNull CallbackRhinoBinder binder)
	{
		super(parent, binder);
	}

	public void prepareDebugSubObjectBase(@NotNull Context ctx) throws Exception
	{
		super.prepareObjectBase(ctx);
	}

	//===========================================================================

	@RhinoCallback
	public boolean jsGet_enabled()
	{
		return globals.debugFlag;
	}

	@RhinoCallback
	public boolean jsGet_filters()
	{
		return globals.debugFilters;
	}

	@RhinoCallback
	public boolean jsGet_httpServer()
	{
		return globals.debugHttpServer;
	}

	@RhinoCallback
	public boolean jsGet_httpClient()
	{
		return globals.debugHttpClient.get();
	}

	@RhinoCallback
	public boolean jsGet_networkConfig()
	{
		return globals.debugNetworkConfig.get();
	}

	@RhinoCallback
	public boolean jsGet_verbose()
	{
		return globals.debugVerbose;
	}
}
