/* Copyright (C) 2008-2015 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.glimmerblocker.proxy.rule;

import org.jetbrains.annotations.Nullable;

public enum ElementPlacementType
{
	HeadStart,
	HeadEnd,
	BodyStart,
	BodyEnd;

	public static ElementPlacementType fromXmlValue(@Nullable String v) throws IllegalArgumentException
	{
		if (v == null || v.equals("body-end"))
			return BodyEnd;
		if (v.equals("head-start"))
			return HeadStart;
		if (v.equals("head-end"))
			return HeadEnd;
		if (v.equals("body-start"))
			return BodyStart;
		throw new IllegalArgumentException("Invalid placement='" + v + "'");
	}
}
