/* Copyright (C) 2008-2012 Peter Speck
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

//#undef DEBUG
//#define DEBUG 1

#ifdef DEBUG
#define DebugNSLog(fmt, ...) NSLog(fmt, ## __VA_ARGS__)
#else
#define DebugNSLog(fmt, ...) do { } while (0)
#endif

extern NSString *PROXY_LAUNCHD_ID;
extern NSString *UPDATER_LAUNCHD_ID;

extern NSString *INSTALLER_BUNDLE_ID;

extern NSString* LAST_UPDATE_CHECK_MARKER_PATH;
extern NSString *CHANNEL_DEV_PATH;
extern NSString *CHANNEL_BETA_PATH;

extern const char* glimmerAuthString;

@interface GBDebug : NSObject {
}

+ (void)debugDumpExceptionStackframe:(NSException*)ex;
+ (void)debugDumpStackframe;


+ (BOOL)verifyCodesign;

+ (NSData*)md5:(NSData*)data;
+ (NSString*)md5Hex:(NSData*)data;

+ (NSString*)proxyPlistPath;
+ (NSString*)updaterPlistPath;
+ (NSString*)updaterBundlePath;
+ (NSString*)proxyBundlePath;
+ (NSString*)proxyBinaryPath;

+ (NSString*)percentEscapeUrlParameterValue:(NSString*)s;

+ (void)setPop:(NSPopUpButton*)popup
		values:(__strong NSString*[])values
 selectedValue:(NSString*)selectedValue
  defaultValue:(NSString*)defaultValue;

+ (void)setVertMatrix:(NSMatrix*)matrix
			   values:(__strong NSString*[])values
		selectedValue:(NSString*)selectedValue
		 defaultValue:(NSString*)defaultValue;

+ (NSString*)findCommandAbsPath:(NSString*)name;
+ (int)executeCommandlineTool:(NSString*)cmd
					 withArgs:(NSArray*)args;
+ (int)executeCommandlineTool:(NSString*)cmd
					 withArgs:(NSArray*)args
				 optStdinData:(NSData*)stdinData
				optStdoutData:(NSMutableData*)stdoutData;
+ (int)executeCommandlineTool:(NSString*)cmd
					 withArgs:(NSArray*)args
				 stdoutString:(NSMutableString*)stdoutString;

+ (void)safeSaveFileAtPath:(NSString *)path contents:(NSData *)data;


+ (NSString*)fingerprintOptionForInstalledPanel:(NSBundle*)prefsPanelBundle;
+ (BOOL)fingerprintForRunningServerIsValid:(NSBundle*)prefsPanelBundle;

/* Disabled: too many users modify installation by trimming platforms using e.g. Monolingual. */
#define REQUIRED_VALID_CODESIGN 0

@end

